unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: Pieter Praet <pieter@praet.org>
To: Dmitry Kurochkin <dmitry.kurochkin@gmail.com>
Cc: Notmuch Mail <notmuch@notmuchmail.org>
Subject: [PATCH] test: don't bail out of `run_emacs' too early when missing prereqs
Date: Thu, 12 Jan 2012 18:16:59 +0100	[thread overview]
Message-ID: <1326388619-17422-1-git-send-email-pieter@praet.org> (raw)
In-Reply-To: <87d3aolu61.fsf@praet.org>

When running the Emacs tests in verbose mode, only the first missing
prereq is reported because the `run_emacs' function is short-circuited
early:

  #+begin_example
    emacs: Testing emacs interface
     missing prerequisites: [0]  emacs(1)
     skipping test: [0]  Basic notmuch-hello view in emacs
     SKIP   [0]  Basic notmuch-hello view in emacs
  #+end_example

This can lead to situations reminiscent of "dependency hell", so instead
of returning based on each individual `test_require_external_prereq's exit
status, we now do so by checking $test_subtest_missing_external_prereqs_:

  #+begin_example
    emacs: Testing emacs interface
     missing prerequisites: [0]  dtach(1) emacs(1) emacsclient(1)
     skipping test: [0]  Basic notmuch-hello view in emacs
     SKIP   [0]  Basic notmuch-hello view in emacs
  #+end_example

Also add missing prereq for dtach(1).

---
 test/test-lib.sh |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

diff --git a/test/test-lib.sh b/test/test-lib.sh
index 82767c0..6ec3882 100644
--- a/test/test-lib.sh
+++ b/test/test-lib.sh
@@ -907,8 +907,10 @@ EOF
 
 test_emacs () {
 	# test dependencies beforehand to avoid the waiting loop below
-	test_require_external_prereq emacs || return
-	test_require_external_prereq emacsclient || return
+	test_require_external_prereq dtach
+	test_require_external_prereq emacs
+	test_require_external_prereq emacsclient
+	test -z "$test_subtest_missing_external_prereqs_" || return
 
 	if [ -z "$EMACS_SERVER" ]; then
 		server_name="notmuch-test-suite-$$"
-- 
1.7.8.1

  reply	other threads:[~2012-01-12 17:18 UTC|newest]

Thread overview: 30+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2011-11-17 13:05 [PATCH v2 00/10] test: (hopefully) better test prerequisites Dmitry Kurochkin
2011-11-17 13:05 ` [PATCH v2 01/10] test: move subtest variables reset into a dedicated function Dmitry Kurochkin
2011-11-17 13:05 ` [PATCH v2 02/10] test: set EMACS_SERVER variable only after dtach(1) was successfully started Dmitry Kurochkin
2011-11-17 13:05 ` [PATCH v2 03/10] test: add test state reset to test_expect_* functions that did not have it Dmitry Kurochkin
2011-11-27 16:19   ` David Bremner
2011-11-27 18:36     ` [PATCH v3 00/7] test: (hopefully) better test prerequisites Dmitry Kurochkin
2011-11-27 18:36       ` [PATCH v3 1/7] test: add support for external executable dependencies Dmitry Kurochkin
2011-11-27 18:36       ` [PATCH v3 2/7] test: fix "skipping test" verbose output Dmitry Kurochkin
2011-11-27 18:36       ` [PATCH v3 3/7] test: skip all subtests if external dependencies are missing during init Dmitry Kurochkin
2011-11-27 18:36       ` [PATCH v3 4/7] test: declare external dependencies for the tests Dmitry Kurochkin
2011-11-27 18:36       ` [PATCH v3 5/7] test: add function to explicitly check for external dependencies Dmitry Kurochkin
2011-11-27 18:36       ` [PATCH v3 6/7] test: check if emacs is available in the beginning of test_emacs Dmitry Kurochkin
2011-11-27 18:36       ` [PATCH v3 7/7] test: fix "Stashing in notmuch-search" test when emacs is not available Dmitry Kurochkin
2011-11-28  7:31       ` [PATCH v3 00/7] test: (hopefully) better test prerequisites David Bremner
2012-01-12 17:14       ` Pieter Praet
2012-01-12 17:16         ` Pieter Praet [this message]
2012-01-12 17:34           ` [PATCH] test: don't bail out of `run_emacs' too early when missing prereqs Dmitry Kurochkin
2012-01-14  9:07             ` Pieter Praet
2012-01-14  9:09               ` Pieter Praet
2012-01-15 13:50                 ` Dmitry Kurochkin
2012-01-16  2:44                 ` David Bremner
2012-01-15 13:56               ` Dmitry Kurochkin
2012-01-16 10:40                 ` Pieter Praet
2011-11-17 13:05 ` [PATCH v2 04/10] test: add support for external executable dependencies Dmitry Kurochkin
2011-11-17 13:05 ` [PATCH v2 05/10] test: fix "skipping test" verbose output Dmitry Kurochkin
2011-11-17 13:05 ` [PATCH v2 06/10] test: skip all subtests if external dependencies are missing during init Dmitry Kurochkin
2011-11-17 13:06 ` [PATCH v2 07/10] test: declare external dependencies for the tests Dmitry Kurochkin
2011-11-17 13:06 ` [PATCH v2 08/10] test: add function to explicitly check for external dependencies Dmitry Kurochkin
2011-11-17 13:06 ` [PATCH v2 09/10] test: check if emacs is available in the beginning of test_emacs Dmitry Kurochkin
2011-11-17 13:06 ` [PATCH v2 10/10] test: fix "Stashing in notmuch-search" test when emacs is not available Dmitry Kurochkin

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1326388619-17422-1-git-send-email-pieter@praet.org \
    --to=pieter@praet.org \
    --cc=dmitry.kurochkin@gmail.com \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).